ElementKindVisitorPreview (Java SE 25 & JDK 25)
Description: declaration: module: java.compiler, package: javax.lang.model.util, class: ElementKindVisitorPreview
Keywords: javax.lang.model.util.ElementKindVisitorPreview class

# Class ElementKindVisitorPreview<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor7<R,P>
javax.lang.model.util.ElementKindVisitor8<R,P>
javax.lang.model.util.ElementKindVisitor9<R,P>
javax.lang.model.util.ElementKindVisitor14<R,P>
javax.lang.model.util.ElementKindVisitorPreview<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

@SupportedSourceVersion(RELEASE_25) public class ElementKindVisitorPreview<R,P> extends ElementKindVisitor14<R,P>
`ElementKindVisitorPreview` is a reflective preview API of the Java platform.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
A visitor of program elements based on their kind with default behavior appropriate for a preview source version. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  23
See Also:
  - Expected visitor evolution
  - Compatibility note for subclasses
  - `ElementKindVisitor6`
  - `ElementKindVisitor7`
  - `ElementKindVisitor8`
  - `ElementKindVisitor9`
  - `ElementKindVisitor14`

- ## Field Summary

  ### Fields declared in class SimpleElementVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ElementKindVisitorPreview()`
  Constructor for concrete subclasses; uses `null` for the default value.
  `protected`
  `ElementKindVisitorPreview(R defaultValue)`
  Constructor for concrete subclasses; uses the argument for the default value.

- ## Method Summary

  ### Methods declared in class ElementKindVisitor14

  `visitRecordComponent, visitTypeAsRecord, visitVariableAsBindingVariable`

  ### Methods declared in class ElementKindVisitor9

  `visitModule`

  ### Methods declared in class ElementKindVisitor7

  `visitVariableAsResourceVariable`

  ### Methods declared in class ElementKindVisitor6

  `visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeParameter, visitVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`

  ### Methods declared in class SimpleElementVisitor6

  `defaultAction`

  ### Methods declared in class AbstractElementVisitor6

  `visit, visit, visitUnknown`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ElementKindVisitorPreview

    protected ElementKindVisitorPreview()
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### ElementKindVisitorPreview

    protected ElementKindVisitorPreview(R defaultValue)
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`